/*
 * Hash_GetKey.c --
 *
 *      Source code for the Hash_GetKey library procedure.
 *
 */

static char rcsid[] __attribute__ ((unused)) =
"$Id: Hash_GetKey.c,v 1.1 2001/12/12 23:01:56 bakers Exp $";

#include "hash.h"
#include "list.h"

/*
 * Hash_GetKey --
 *
 *      Return the key corresponding to the entry entryPtr.
 *
 * Results:
 *      A pointer to the key is returned.
 *
 * Side Effects:
 *      None.
 */

Address
Hash_GetKey (tablePtr, entryPtr)
    Hash_Table *tablePtr;
    register Hash_Entry *entryPtr;
{
    register int numKeys;

    numKeys = tablePtr->keyType;
    switch (numKeys) {
      case 0:
          return (Address) entryPtr->key.name;
      case 1:
          return (Address) entryPtr->key.ptr;
      default:
          return (Address) entryPtr->key.words;
    }
}
