//---------------------------------------------------------------------------

#ifndef htH
#define htH

#include <status.h>
#include "nfs.h"

#define HANDLE_HASH_OFFSET 24
#define HANDLE_HASH_SIZE (32 - HANDLE_HASH_OFFSET)
#define HANDLE_HASH_SECRET "secret"

typedef struct THandleKey {
    int pin;
    int pfs;
    int sid;
    int mountChecksum;
} THandleKey;

typedef struct THandleEntry {
    struct nfs_fh pfh;
    int vin;
} THandleEntry;

Status HandleInit(void);
Status HandleCreateKey(int pin, int pfs, int sid, int mountChecksum,
    THandleKey *key);
Status HandleValidate(char *vfh);
int HandleCreateVin(void);
int HandleGetVINFromVFH(struct nfs_fh *vfh);
int HandleGetParentVINFromVFH(struct nfs_fh *vfh);
Status HandleCreate(THandleKey *key, int vin, struct nfs_fh *pfh, THandleEntry **entry);
Status HandleLookup(THandleKey *key, THandleEntry **entry);
Status HandleLookupOrCreate(THandleKey *handleKey, struct nfs_fh *pfh,
    THandleEntry **handleEntry);
Status HandleCreateVFH(THandleKey *key, THandleEntry *entry, int pvin,
    int dosId, struct nfs_fh *vfh);
Status HandleCreateKeyFromVFH(struct nfs_fh *vfh, THandleKey *key);

//---------------------------------------------------------------------------
#endif










