/*
 *  The Mirage NFS Router
 *
 *  @COPYRIGHT@
 *
 *  lcache.c: Lookup cache
 *
 *  this was never implemented...
 *
 */

#include "nfsroute.h"

#define MAX_LOOKUP_KEY 1024+8

Hash_Table LookupHashTable;

void CreateLookupKey(int pvin, char *childName, char *key)
{
    sprintf(key,"%x", pvin);
    strcat(key, childName);
}

Status LookupCacheInit()
{
    Hash_InitTable(&LookupHashTable, 0, HASH_STRING_KEYS);

    return SUCCESS;
}

Status LookupCacheAdd(int pvin, char *childName, struct nfs_fh *vfh)
{
    char key[MAX_LOOKUP_KEY];
    Hash_Entry *h;
    Boolean isNew;
    struct nfs_fh *fhNew;

    CreateLookupKey(pvin, childName, key);

    fhNew = (struct nfs_fh *) malloc(sizeof(struct nfs_fh));
    memcpy(fhNew, vfh, sizeof(struct nfs_fh));

    h = Hash_CreateEntry(&LookupHashTable, (void*) key, &isNew);
    Hash_SetValue(h, fhNew);

    return SUCCESS;
}

Status LookupCacheFind(int pvin, char *childName, struct nfs_fh *vfh)
{
    char key[MAX_LOOKUP_KEY];
    Hash_Entry *h;
    struct nfs_fh *fhCache;

    CreateLookupKey(pvin, childName, key);

    h = Hash_FindEntry(&LookupHashTable, (void*) key);
    if (h == NULL) {
        return FAILURE;
    }

    fhCache = (struct nfs_fh *) Hash_GetValue(h);

    memcpy(vfh, h, sizeof(struct nfs_fh));

    return SUCCESS;
}

Status LookupCacheDelete(int pvin, char *childName)
{
    char key[MAX_LOOKUP_KEY];
    Hash_Entry *h;
    struct nfs_fh *fhCache;

    CreateLookupKey(pvin, childName, key);

    h = Hash_FindEntry(&LookupHashTable, (void*) key);
    if (h == NULL) {
        return FAILURE;
    }

    Hash_DeleteEntry(&LookupHashTable, h);

    return SUCCESS;
}



