/*
 *  The Mirage NFS Router
 *
 *  @COPYRIGHT@
 *
 *  nfstable.h: implements the mapping table between VH and PH
 *
 */

#ifndef nfstableH
#define nfstableH

#include "nfs.h"

#define FLAG_FILEID 1
#define FLAG_FSID 2
#define FLAG_PH 4
#define FLAG_VH 8
#define FLAG_SERVER 16

/*
 * TableNode structure
 *
 *     This structure holds the mapping between VH and PH, as well as inodes,
 *     server numbers, etc.
 *
 * XXX many of the fields can probably be eliminated since they are duplicated
 *     in the VH itself. XXX
 */

typedef struct TableNode {
    int flags;
    int fileId;
    int fsid;
    int server;
    struct nfs_fh ph;
    int vfsid;
    int vfileId;
    struct nfs_fh vh;
    struct TableNode *next;
} TableNode;

int TableGetServerFromVH(struct nfs_fh *vh, int *server);
int TableGetPH(struct nfs_fh *vh, struct nfs_fh *ph);
int TableGetVH(int flags, int fileId, int fsid, int server, struct nfs_fh *ph,
        int *vfsid, int *vfileid, struct nfs_fh *vh);

#endif










