//---------------------------------------------------------------------------

#ifndef rejectH
#define rejectH

#include <hash.h>
#include <status.h>

//#define BIT(x) (1 << (x))

#define INVAL_NONE 0
#define INVAL_CREATEDIRENTS 1
#define INVAL_REMOVEDIRENTS 2
#define INVAL_SETATTR 3
#define INVAL_LOWERQUOTA 4
#define INVAL_REMOVEDIRENTSCHILD 5

#define REJECT_UID_ANY -1
#define REJECT_GID_ANY -1
#define REJECT_VIN_ANY -1
#define REJECT_FILENAME_ANY NULL

#define MAX_REJECT_REPLY_SIZE 256
#define MAX_REJECT_FILENAME 256

typedef struct TRejectKey {
    int vin;
    int procNum;
    int uid;
    int gid;
    char filename[MAX_REJECT_FILENAME];
} TRejectKey;

typedef struct TRejectEntry {
    int errorCode;
    int expireTime;
    char replyHeader[MAX_REJECT_REPLY_SIZE];
    int replySize;
    int invalType;
} TRejectEntry;

Status RejectInit(void);

Status RejectCreateKey(int vin, int procedure, int uid, int gid,
        char *filename, TRejectKey *rejectKey);

Status RejectLookup(TRejectKey *rejectKey, TRejectEntry **rejectEntry);
Status RejectCreate(TRejectKey *rejectKey, int errorCode, int expireTime,
        char *replyHeader, int replySize, int invalType);
Status RejectRemove(TRejectKey *rejectKey);

Status RejectInvalidate(int invalType, int proc, int vin, int uid, int gid,
        char *fn);

char *RejectKeyToString(TRejectKey *rejectKey);

//---------------------------------------------------------------------------
#endif










