/*
 *  The Mirage NFS Router
 *
 *  @COPYRIGHT@
 *
 *  score.c: something to do with the old DoS score mechanism. probably obsolete.
 *
 */

#include "nfsroute.h"

#define SCORE_FREELIST

Hash_Table ScoreHashTable;

TScoreEntry *ScoreFreeList;

int TotalScore;

Status ScoreInit()
{
    Hash_InitTable(&ScoreHashTable, 0, HASH_ONE_WORD_KEYS);
    ScoreFreeList = NULL;

    return SUCCESS;
}

TScoreEntry *ScoreEntryAlloc()
{
    TScoreEntry *entry;

    if (ScoreFreeList!=NULL) {
        entry = ScoreFreeList;
        ScoreFreeList = ScoreFreeList->next;
    } else {
        entry = (TScoreEntry*) MALLOC(sizeof(TScoreEntry));
    }

    return entry;
}

void ScoreEntryFree(TScoreEntry *entry)
{
#ifdef UMT_FREELIST
    entry->next = ScoreFreeList;
    ScoreFreeList = entry;
#else
    FREE(entry);
#endif
}

void ScoreAddToHash(TScoreKey scoreKey, TScoreEntry *scoreEntry)
{
    Hash_Entry *h;
    Boolean isNew;

    h = Hash_CreateEntry(&ScoreHashTable, (void*) scoreKey, &isNew);
    Hash_SetValue(h, scoreEntry);

    scoreEntry->h = h;
}

int ScoreUpdate(TScoreKey scoreKey, int score_to_add, TTimeStamp tNow)
{
    TScoreEntry *scoreEntry;
    Hash_Entry *h;
    double factor;
    TTimeStamp tDelta;

    h = Hash_FindEntry(&ScoreHashTable, (void*) scoreKey);
    if (h == NULL) {
        scoreEntry = ScoreEntryAlloc();
        scoreEntry->score = 0;
        scoreEntry->timeStamp = tNow;
        ScoreAddToHash(scoreKey, scoreEntry);

    } else {
        scoreEntry = (TScoreEntry *) Hash_GetValue(h);
    }

    // remove the old score from the total
    TotalScore = TotalScore - scoreEntry->score;

    tDelta = tNow-scoreEntry->timeStamp;
    if (tDelta == 0) {
        return scoreEntry->score;
//        tDelta = 1;
    }
    scoreEntry->score = (0.9*scoreEntry->score) + (0.1*score_to_add/tDelta);
    /*
    if (tDelta <= 1) {
        factor = 1;
    } else {
        factor = 0.9 + 0.1/tDelta;
    }
    MirageDebug("%d %1.1f\n", tDelta, factor);
    scoreEntry->score = (scoreEntry->score*factor) + score_to_add;*/
    scoreEntry->timeStamp = tNow;

    // add the new score to the total
    TotalScore = TotalScore + scoreEntry->score;

    return scoreEntry->score;
}

int ScoreComputeNfs(int nfsProcNum, int packetLen)
{
    int score_to_add;

    score_to_add = 1000 + packetLen/4;

    switch (nfsProcNum) {
        case NFSPROC_NULL:
            break;

        case NFSPROC_GETATTR:
        case NFSPROC_LOOKUP:
        case NFSPROC_READLINK:
        case NFSPROC_READ:
        case NFSPROC_READDIR:
        case NFSPROC_STATFS:
            /* things that read */
            break;

        case NFSPROC_SYMLINK:
        case NFSPROC_RENAME:
        case NFSPROC_LINK:
        case NFSPROC_RMDIR:
        case NFSPROC_REMOVE:
            /* things that operate on directories */
            score_to_add += 500;
            break;

        case NFSPROC_WRITE:
            /* things that write */
            score_to_add += 1000;
            break;

        case NFSPROC_MKDIR:
        case NFSPROC_CREATE:
            /* things that create new objects */
            score_to_add += 2000;
            break;
    }

    return score_to_add;
}


int ScoreUpdateNfs(TScoreKey scoreKey,
    int nfsProcNum,
    int packetLen,
    TTimeStamp tNow)
{
    int scoreToAdd;

    scoreToAdd = ScoreComputeNfs(nfsProcNum, packetLen);

    return ScoreUpdate(scoreKey, scoreToAdd, tNow);
}

int ScoreIsExcessive(int score)
{
    if ((score > TotalScore/4) && (TotalScore > 2000000)) {
        return TRUE;
    } else {
        return FALSE;
    }
}

/* if we need to refcount...
Status ScoreFree(TScoreEntry *scoreEntry)
{
    scoreEntry->refCount--;
    if (scoreEntry->refCount <= 0) {
        Hash_Entry *h = scoreEntry->h;
        ScoreEntryFree(scoreEntry);

        if (h != NULL) {
            Hash_DeleteEntry(&ScoreHashTable, h);
        }
    }

    return SUCCESS;
}
*/


