//---------------------------------------------------------------------------

#ifndef transactH
#define transactH

#include <status.h>

#define MAX_LOOKUP_FILENAME 256

typedef struct TTransactKey {
    int xid;
    int clientIp;
} TTransactKey;

typedef struct TTransactEntry {
    int proc;
    int vin;
    int mountChecksum;
    int uid;
    int gid;

    int timeStamp;

    // valid DOS checking fields
    int dosId;

    // invalid DOS checking fields
#ifdef TT_HAS_INVALID_DOS_FIELDS
    int pvin;
    char filename[MAX_LOOKUP_FILENAME];
    int vin2;
    char filename2[MAX_LOOKUP_FILENAME];
#endif

    int refCount;
    Hash_Entry *h;
    struct TTransactEntry *next;

    struct Path *returnPath;
} TTransactEntry;

Status TransactInit(void);
Status TransactCreateKey(int xid, int clientIp, TTransactKey *key);
Status TransactCreate(TTransactKey *key, int proc, int vin, int mountChecksum,
        int uid, int gid, int dosId, TTransactEntry **entryOut);
Status TransactFillInvalidDosFields(TTransactEntry *entry,
        char *filename, int pvin, int vin2, char *filename2);
Status TransactLookup(TTransactKey *key, TTransactEntry **entry);
Status TransactFree(TTransactEntry *entry);
int TransactGetOutstanding();
void TransactPurge(int maxAge);

//---------------------------------------------------------------------------
#endif










