/*
 *  The Mirage NFS Router
 *
 *  @COPYRIGHT@
 *
 *  umtSilk.c
 *
 *  NOTE: Any changes to this file should also be made to umt.c !!
 *
 * Implements a modified version of the UMT for silk. Since silk has per-path
 * state, there's no reason for a UMT hash table, so this file implements stubs
 * that put the UMT entry into the per-path state.
 *
 */

#include "nfsroute.h"

extern TUmtEntry *SilkUmtEntry;
extern int *SilkUmtKey;

int UmtXidCounter = 0;
Hash_Table UmtHashTable;

Status UmtInit()
{
    return SUCCESS;
}

Status UmtCreate(int oldXid, int clientIp, int clientPort, int *newXid,
    TUmtEntry **umtEntryOut)
{
    TUmtEntry *umtEntry;

    *newXid = UmtXidCounter++;

    umtEntry = SilkUmtEntry;
    umtEntry->oldXid = oldXid;
    umtEntry->clientIp = clientIp;
    umtEntry->clientPort = clientPort;
    umtEntry->refCount = 1;
    umtEntry->h = NULL;

    if (umtEntryOut) {
        *umtEntryOut = umtEntry;
    }

    *SilkUmtKey = *newXid;

    return SUCCESS;
}

Status UmtLookup(int newXid, TUmtEntry **umtEntryOut)
{
    if (*SilkUmtKey != newXid) {
        return FAILURE;
    }

    if (umtEntryOut) {
        *umtEntryOut = SilkUmtEntry;
    }

    return SUCCESS;
}

Status UmtFree(TUmtEntry *umtEntry)
{
    return SUCCESS;
}



