/*
 *  The Mirage NFS Router
 *
 *  @COPYRIGHT@
 *
 *  xdr.h: prototypes for XDR encoding and decoding functions
 *
 */

#ifndef xdrH
#define xdrH

#include "nfs.h"

#define XDR_QUADLEN(l)            (((l) + 3) >> 2)

#define AUTH_NONE 0
#define AUTH_UNIX 1

char *xdr_decode_rpcrequest(char *inp, int *xid, int *proc);
char *xdr_decode_rpcreply(char *inp, int *xid, int *stat);
char *xdr_decode_fhstatus(char *inp, struct mnt_fhstatus *res);
char *xdr_decode_fhstatus3(char *inp, struct mnt_fhstatus *res);
char *xdr_decode_nfsstat(char *inp, int *nfsstat);
char *xdr_decode_fhandle(char *inp, struct nfs_fh *fh);

char *xdr_encode_handle(char *outp, struct nfs_fh *handle);
char *xdr_encode_handle3(char *outp, struct nfs_fh *handle);

int xdr_getuidgid(char *inp, int *uid, int *gid);

#endif
